package cn.teammodel.controller.frontend;

import cn.teammodel.common.R;
import cn.teammodel.repository.AppraiseRepository;
import io.swagger.annotations.Api;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
@RequestMapping("/")
@Api(tags = "鉴权测试")
public class HelloController {

    @Resource
    private AppraiseRepository appraiseRepository;

    @GetMapping("hello")
    @PreAuthorize("@ss.hasRole('admin')")
    public R<String> hello() {
        System.out.println(SecurityContextHolder.getContext().getAuthentication());

        return new R(200, "success","hello world");
    }
    @GetMapping("public/free")
    @PreAuthorize("permitAll()")
    public R<String> free() {
        return new R(200, "success","hello world");
    }
}