package cn.teammodel.repository;

import cn.teammodel.model.entity.weekDuty.WeekDutyRecord;
import cn.teammodel.model.vo.weekDuty.DutyRecordVo;
import com.azure.spring.data.cosmos.repository.CosmosRepository;
import com.azure.spring.data.cosmos.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author winter
 * @create 2024-01-04 17:23
 */
@Repository
public interface DutyRecordRepository extends CosmosRepository<WeekDutyRecord, String> {
    WeekDutyRecord findByClassIdAndAcademicYearIdAndCode(String classId, String academicYearId, String code);

    @Query(value = "SELECT c.id as recordId, c.classId, c.className, n as info FROM c join n in c.nodes WHERE " +
            "c.code = @code " +
            "AND c.academicYearId = @academicYearId " +
            "AND n.creatorId = @userId " +
            "AND (IS_NULL(@classId) or c.classId = @classId) " +
            "AND (IS_NULL(@positive) or n.dutyTreeNode.positive = @positive) " +
            "AND (IS_NULL(@startTime) or n.createTime >= @startTime)  " +
            "AND (IS_NULL(@endTime) or n.createTime <= @endTime)")
    List<DutyRecordVo> findRecordsByConditions(String code, String academicYearId, String userId, String classId, Boolean positive, Long startTime, Long endTime);
}

